/*
BinEditControl(Window) 20070805-
 by Murachue

TODO:
 This control not supported proportional font.
 This control not supported over 32768lines(16*32768=524288bytes).

bibliography:
 Win32 API(Lbg(eLXgJ[\)gpɂ)
  http://www.dev.pei.jp/programming/sdk/sdk5.html
 }EXzC[ł̈ړsD
  http://rararahp.cool.ne.jp/cgi-bin/lng/vc/vclng.cgi?print+200212/02120070.txt

*/

// for Wheel
#define _WIN32_WINDOWS 0x0410
#define _WIN32_WINNT 0x0410

#include <windows.h>
#include "halloc.h"
#include "binedit.h"

#define ChangeWindowLong(hwnd, id, del, add)	SetWindowLong(hwnd, id, GetWindowLong(hwnd, id) & ~(del) | (add))

struct tagBEV	// BinEditVal
{
	BYTE* data;
	DWORD size;

	UINT caretpos;

	UINT selstart;
	UINT sellength;

	BOOL activeside;	// FALSE: left-hex, TRUE: right-binary

	HFONT font;
	SIZE cmsize;

	BOOL showingcaret;
};
#define SIDE_LEFT FALSE
#define SIDE_RIGHT TRUE

void draw(HWND hWnd, struct tagBEV* bev, HDC hdc)
{
	RECT rc;
	BOOL isActive;

	GetClientRect(hWnd, &rc);

	SelectObject(hdc, GetSysColorBrush(COLOR_WINDOW));
	SelectObject(hdc, GetStockObject(NULL_PEN));
	SelectObject(hdc, bev->font);

	Rectangle(hdc, 0, 0, rc.right + 1, rc.bottom + 1);

	isActive = (GetFocus() == hWnd);
	// DrawHeader
	SetBkColor(hdc, isActive ? RGB(0xC0, 0xC0, 0xC0) : RGB(0xFF, 0xFF, 0xFF));
	SetTextColor(hdc, RGB(0x00, 0x00, 0x00));
	//									 123456789_123456789_123456789_123456789_123456789_123456789_12345
	TextOut(hdc, bev->cmsize.cx * 8, 0, TEXT("+0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F  0123456789ABCDEF"), 65);

	// DrawData
	if(bev->data)
	{
		TCHAR ts[9];
		UINT i;
		BYTE* data;
		UINT len;
		UINT soffs;
		UINT loffs;

		UINT lines;

		BOOL issetcaret = FALSE;

		soffs = GetScrollPos(hWnd, SB_VERT) * 16;
		lines = (rc.bottom + (bev->cmsize.cy - 1)) / bev->cmsize.cy;

		for(loffs = 0, data = bev->data + soffs, len = bev->size - soffs; loffs < lines && len; loffs++)
		{
			BYTE* d;
			UINT l;

			SetBkColor(hdc, isActive ? RGB(0xC0, 0xC0, 0xC0) : RGB(0xFF, 0xFF, 0xFF));
			SetTextColor(hdc, RGB(0x00, 0x00, 0x00));

			wsprintf(ts, TEXT("%06X"), soffs + loffs * 16);
			TextOut(hdc, 0, bev->cmsize.cy * (1 + loffs), ts, 6);

			SetBkColor(hdc, GetSysColor(COLOR_WINDOW));
			SetTextColor(hdc, GetSysColor(COLOR_WINDOWTEXT));

			for(i = 0, d = data, l = len; i < 16 && l; i++, d++, l--)
			{
				UINT tsl = 2;

				wsprintf(ts, TEXT("%02X"), *d);
				if(i == 7)
					lstrcat(ts, TEXT("-")), tsl = 3;
				TextOut(hdc, bev->cmsize.cx * (8 + i * 3), bev->cmsize.cy * (1 + loffs), ts, tsl);

				if((UINT)(d - bev->data) == bev->caretpos)
				{
					int cposx = bev->cmsize.cx * (8 + i * 3);
					int cposy = bev->cmsize.cy * (1 + loffs);

					if(isActive && bev->activeside == SIDE_LEFT)
					{
						SetCaretPos(cposx, cposy);

						issetcaret = TRUE;
					}else
					{
						int oldrop = SetROP2(hdc, R2_XORPEN);

						if(bev->activeside == SIDE_LEFT)
						{	// Activated-inactive
							SelectObject(hdc, GetStockObject(WHITE_PEN));
							SelectObject(hdc, GetStockObject(NULL_BRUSH));
							Rectangle(hdc, cposx, cposy, cposx + bev->cmsize.cx, cposy + bev->cmsize.cy);
						}else
						{	// Inactivated-inactive
							SelectObject(hdc, GetStockObject(NULL_PEN));
							SelectObject(hdc, GetStockObject(WHITE_BRUSH));
							Rectangle(hdc, cposx, cposy, cposx + bev->cmsize.cx + 1, cposy + bev->cmsize.cy + 1);
						}

						SetROP2(hdc, oldrop);
					}
				}
			}

			for(i = 0; i < 16 && len; i++, data++, len--)
			{
				if(0x20 <= *data && *data <= 0x7E)
					wsprintf(ts, TEXT("%c"), *data);
				else
					lstrcpy(ts, TEXT("."));

				TextOut(hdc, bev->cmsize.cx * (8 + 16*3 + 1 + i), bev->cmsize.cy * (1 + loffs), ts, 1);

				if((UINT)(data - bev->data) == bev->caretpos)
				{
					int cposx = bev->cmsize.cx * (8 + 16*3 + 1 + i);
					int cposy = bev->cmsize.cy * (1 + loffs);

					if(isActive && bev->activeside == SIDE_RIGHT)
					{
						SetCaretPos(cposx, cposy);

						issetcaret = TRUE;
					}else
					{
						int oldrop = SetROP2(hdc, R2_XORPEN);

						if(bev->activeside == SIDE_RIGHT)
						{	// Activated-inactive
							SelectObject(hdc, GetStockObject(WHITE_PEN));
							SelectObject(hdc, GetStockObject(NULL_BRUSH));
							Rectangle(hdc, cposx, cposy, cposx + bev->cmsize.cx, cposy + bev->cmsize.cy);
						}else
						{	// Inactivated-inactive
							SelectObject(hdc, GetStockObject(NULL_PEN));
							SelectObject(hdc, GetStockObject(WHITE_BRUSH));
							Rectangle(hdc, cposx, cposy, cposx + bev->cmsize.cx + 1, cposy + bev->cmsize.cy + 1);
						}

						SetROP2(hdc, oldrop);
					}
				}
			}
		}

		if(issetcaret != bev->showingcaret)
		{
			if(issetcaret)
				ShowCaret(hWnd);
			else
				HideCaret(hWnd);
			bev->showingcaret = issetcaret;
		}
	}else
	{	// no data.
		SetCaretPos(bev->cmsize.cx * 8, bev->cmsize.cy * 1);
		if(GetFocus() == hWnd && bev->showingcaret == FALSE)
		{
			ShowCaret(hWnd);
			bev->showingcaret = TRUE;
		}
	}

	return;
}

void ensureVisible(HWND hWnd, struct tagBEV* bev)
{
	UINT scrollpos;
	RECT rc;

	scrollpos = GetScrollPos(hWnd, SB_VERT);
	GetClientRect(hWnd, &rc);

	if(bev->caretpos < scrollpos * 16)	// Lbg݈ʒuO
	{
		SetScrollPos(hWnd, SB_VERT, bev->caretpos / 16, TRUE);
		InvalidateRect(hWnd, NULL, FALSE);
	}
	if(scrollpos * 16 + (rc.bottom / bev->cmsize.cy/*؂̂Ăł?*/ - 1/*header-line*/ - 1) * 16 < bev->caretpos)	// Lbg낷鎞
	{
		SetScrollPos(hWnd, SB_VERT, bev->caretpos / 16 - (rc.bottom / bev->cmsize.cy - 1 - 1), TRUE);
		InvalidateRect(hWnd, NULL, FALSE);
	}

	return;
}

LRESULT CALLBACK bineditWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_CREATE:
		// m&Set
		{
			struct tagBEV* bev;

			bev = halloc(sizeof(struct tagBEV));

			bev->data = 0;
			bev->size = 0;
			bev->caretpos = 0;
			bev->selstart = 0;
			bev->sellength = 0;
			bev->activeside = SIDE_LEFT;
			bev->showingcaret = FALSE;

			SetWindowLong(hWnd, 0, (LONG)bev);
		}

		ChangeWindowLong(hWnd, GWL_STYLE, 0, WS_VSCROLL);

		return 0;
	case WM_DESTROY:
		// 
		{
			struct tagBEV* bev = (void*)GetWindowLong(hWnd, 0);

			if(bev->data)
				hfree(bev->data);

			hfree(bev);
		}
		return 0;

	case WM_SETFOCUS:
		{
			struct tagBEV* bev = (void*)GetWindowLong(hWnd, 0);

			/* Lbg쐬 */
			CreateCaret(hWnd, NULL, bev->cmsize.cx, bev->cmsize.cy);
			/* ʒuݒ */
			SetCaretPos(0, 0);
			// Lbg\
			//ShowCaret(hWnd);

			bev->showingcaret = FALSE;

			InvalidateRect(hWnd, NULL, FALSE);
		}
		return 0;
	case WM_KILLFOCUS:
		{
			struct tagBEV* bev = (void*)GetWindowLong(hWnd, 0);
			/* Lbg̔j */
			DestroyCaret();

			bev->showingcaret = FALSE;

			InvalidateRect(hWnd, NULL, FALSE);
		}
		return 0;

	case WM_LBUTTONDOWN:
		SetFocus(hWnd);

		{
			struct tagBEV* bev = (void*)GetWindowLong(hWnd, 0);
			int x, y;

			x = (short)LOWORD(lParam) / bev->cmsize.cx - 8;
			if(x < 0)
				x = 0;
			if(3*16 <= x)	// ASCIIside
			{
				x -= 3*16 + 1;
				if(x < 0)
					x = 0;
			}else	// HEXside
				x /= 3;
			y = (short)HIWORD(lParam) / bev->cmsize.cy - 1;
			if(0 <= y && x < 16)
			{
				y += GetScrollPos(hWnd, SB_VERT);
				if(y * 16 + x < (int)bev->size)
				{
					bev->caretpos = y * 16 + x;
					ensureVisible(hWnd, bev);	// ԉNbNƂ
					InvalidateRect(hWnd,  NULL, FALSE);
				}
			}
		}

		return 0;

	case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC hdc;
			struct tagBEV* bev = (void*)GetWindowLong(hWnd, 0);

			hdc = BeginPaint(hWnd, &ps);

			draw(hWnd, bev, hdc);

			EndPaint(hWnd, &ps);
		}
		return 0;

	case WM_SETFONT:
		{
			struct tagBEV* bev = (void*)GetWindowLong(hWnd, 0);

			bev->font = (HFONT)wParam;

			// 1̑傫擾
			{
				HDC hdc;
				HFONT hfold;

				hdc = GetDC(hWnd);
				hfold = SelectObject(hdc, bev->font);
				GetTextExtentPoint32(hdc, TEXT("0"), 1, &bev->cmsize);
				SelectObject(hdc, hfold);
				ReleaseDC(hWnd, hdc);
			}
		}
		return 0;

	case WM_SIZE:
		// XN[o[Ƃ.
		{
			struct tagBEV* bev = (void*)GetWindowLong(hWnd, 0);

			SetScrollRange(hWnd, SB_VERT, 0, (bev->size + 15) / 16 - 1, FALSE);
			SetScrollPos(hWnd, SB_VERT, 0, TRUE);

			InvalidateRect(hWnd, NULL, FALSE);
		}

		return 0;

	case WM_VSCROLL:
		{
			struct tagBEV* bev = (void*)GetWindowLong(hWnd, 0);

			int pos;
			RECT rc;

			pos = GetScrollPos(hWnd, SB_VERT);
			GetClientRect(hWnd, &rc);

			switch(LOWORD(wParam))
			{
			case SB_LINEDOWN:
				pos++;
				break;
			case SB_PAGEDOWN:
				pos += (rc.bottom / bev->cmsize.cy/*؂̂Ăł?*/ - 1/*header-line*/ - 1) / 2;
				break;
			case SB_LINEUP:
				pos--;
				break;
			case SB_PAGEUP:
				pos -= (rc.bottom / bev->cmsize.cy/*؂̂Ăł?*/ - 1/*header-line*/ - 1) / 2;
				break;
			case SB_TOP:
				pos = 0;
				break;
			case SB_BOTTOM:
				pos = bev->size / 16;
				break;
			case SB_THUMBPOSITION:
			case SB_THUMBTRACK:
				pos = HIWORD(wParam);
				break;
			}

			if(pos < 0)
				pos = 0;
			if((int)bev->size / 16 < pos)
				pos = bev->size / 16;

			SetScrollPos(hWnd, SB_VERT, pos, TRUE);

			InvalidateRect(hWnd, NULL, FALSE);
		}

		return 0;

	case WM_MOUSEWHEEL:
		{
			UINT nSysLines;

			SystemParametersInfo(SPI_GETWHEELSCROLLLINES, 0, &nSysLines, 0);	// NTonly!?
			SetScrollPos(hWnd, SB_VERT, GetScrollPos(hWnd, SB_VERT) - (short)HIWORD(wParam) / WHEEL_DELTA * nSysLines/*lines*/, TRUE);

			InvalidateRect(hWnd, NULL, FALSE);
		}

		return 0;

	case WM_KEYDOWN:
		{
			struct tagBEV* bev = (void*)GetWindowLong(hWnd, 0);
	
			switch(wParam)
			{
			case VK_LEFT:
				if(0 <= (int)bev->caretpos - 1)
					bev->caretpos--;
				break;
			case VK_RIGHT:
				if(bev->caretpos + 1 < bev->size)
					bev->caretpos++;
				break;
			case VK_UP:
				if(0 <= (int)bev->caretpos - 16)
					bev->caretpos -= 16;
				break;
			case VK_DOWN:
				if(bev->caretpos + 16 < bev->size)
					bev->caretpos += 16;
				break;

			case VK_PRIOR:
				//{
				//	RECT rc;

				//	GetClientRect(hWnd, &rc);
					bev->caretpos -= 0x100;//(rc.bottom / bev->cmsize.cy/*؂̂Ăł?*/ - 1/*header-line*/ - 1) / 2 * 16;
					if((int)bev->caretpos < 0)
						bev->caretpos = 0;
				//}
				//SendMessage(hWnd, WM_VSCROLL, SB_PAGEUP, 0);
				break;
			case VK_NEXT:
				//{
				//	RECT rc;

				//	GetClientRect(hWnd, &rc);
					bev->caretpos += 0x100;//(rc.bottom / bev->cmsize.cy/*؂̂Ăł?*/ - 1/*header-line*/ - 1) / 2 * 16;
					if(bev->size - 1 < bev->caretpos)
						bev->caretpos = bev->size - 1;
				//}
				//SendMessage(hWnd, WM_VSCROLL, SB_PAGEDOWN, 0);
				break;
			case VK_HOME:
				bev->caretpos = 0;
				//SendMessage(hWnd, WM_VSCROLL, SB_TOP, 0);
				break;
			case VK_END:
				bev->caretpos = bev->size - 1;
				//SendMessage(hWnd, WM_VSCROLL, SB_BOTTOM, 0);
				break;

			case VK_TAB:
				bev->activeside = !bev->activeside;
				break;
			}

			ensureVisible(hWnd, bev);

			InvalidateRect(hWnd, NULL, FALSE);
		}
		return 0;

	case BEM_SETDATA:
		{
			struct tagBEV* bev = (void*)GetWindowLong(hWnd, 0);

			if(bev->data)
				hfree(bev->data);

			if(wParam && lParam)
			{
				bev->size = wParam;
				bev->data = halloc(bev->size);
				memcpy(bev->data, (void*)lParam, bev->size);
			}else
			{
				bev->size = 0;
				bev->data = NULL;
			}

			bev->caretpos = bev->selstart = bev->sellength = 0;

			// Pseudo WM_SIZE message because set scrollbar.
			{
				RECT rc;

				GetClientRect(hWnd, &rc);
				SendMessage(hWnd, WM_SIZE, 0, MAKELPARAM(rc.right, rc.bottom));
			}
		}

		return 0;
	case BEM_SETSEL:
		{
			struct tagBEV* bev = (void*)GetWindowLong(hWnd, 0);

			bev->caretpos = bev->selstart = wParam;
			bev->sellength = lParam;

			InvalidateRect(hWnd, NULL, FALSE);
		}

		return 0;
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}

BOOL bineditInit(void)
{
	WNDCLASSEX wc = {0};

	wc.cbSize = sizeof(wc);
	//wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
	wc.cbWndExtra = sizeof(void*);
	wc.hInstance = GetModuleHandle(NULL);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.lpfnWndProc = bineditWndProc;
	wc.lpszClassName = WC_BINEDIT;

	if(!RegisterClassEx(&wc))
		return FALSE;

	return TRUE;
}

void bineditTerminate(void)
{
	// nothing to do.

	return;
}
